<template>
  <div>
    <v-menu
      ref="menu1"
      v-model="menu1"
      :close-on-content-click="false"
      :return-value.sync="dates"
      transition="scale-transition"
      offset-y
      max-width="290px"
      min-width="auto"
    >
      <template v-slot:activator="{ on, attrs }">
        <v-text-field
          v-model="dateRangeText"
          label="วันที่เริ่ม ~ วันที่จบ"
          outlined
          rounded
          prepend-inner-icon="mdi-calendar"
          readonly
          v-bind="attrs"
          v-on="on"
        ></v-text-field>
      </template>
      <v-date-picker
        v-model="dates"
        ref="picker"
        @input="selectDate"
        reactive
        no-title
        range
      >
        <v-spacer></v-spacer>
        <v-btn text color="primary" @click="saveDate(dates)"> OK </v-btn>
        <v-btn text color="primary" @click="menu1 = false"> Cancel </v-btn>
      </v-date-picker>
    </v-menu>
  </div>
</template>

<script>
import moment from "moment";

export default {
  data() {
    return {
      dates: [],
      dateShow: [],
      menu1: false,
    };
  },
  computed: {
    dateRangeText() {
      this.dateShow[0] = moment(this.dates[0]).locale("th").format("LL");
      this.dateShow[1] = moment(this.dates[1]).locale("th").format("LL");

      return this.dateShow.join(" ~ ");
    },
  },
  created() {
    this.defaultDate();
    this.$emit("update:inputDate", this.dates);
  },

  methods: {
    defaultDate() {
      let dateTh = moment(this.$options.filters.dateNow())
        .add(543, "year")
        .format("YYYY-MM-DD");
      this.dates[1] = dateTh;
      let date = dateTh.split("-");
      let celDate = parseInt(date[2]) - 6;
      if (celDate <= 0) {
        let monthNew = parseInt(date[1]) - 1;
        let yearNew = parseInt(date[0]);
        let calMonthNew = monthNew;
        if (monthNew == 0) {
          yearNew = parseInt(date[0]) - 1;
          calMonthNew = 12 - monthNew;
        }
        let dayCount = this.daysInMonth(calMonthNew, yearNew);
        let unNegative = Math.abs(celDate);
        let calResult = parseInt(dayCount) - unNegative;

        let newDate = moment(`${yearNew}-${calMonthNew}-${calResult}`).format(
          "YYYY-MM-DD"
        );
        this.dates[0] = newDate;
      } else {
        let newDate = moment(`${date[0]}-${date[1]}-${celDate}`).format(
          "YYYY-MM-DD"
        );
        this.dates[0] = newDate;
      }
    },

    daysInMonth(month, year) {
      return new Date(year, month, 0).getDate();
    },
    saveDate(date) {
      this.$refs.menu1.save(date);
      this.$emit("update:inputDate", date);
    },
    selectDate() {
      let dateToString = `${this.dates[0]}`;
      let date = dateToString.split("-");
      let celDate = parseInt(date[2]) + 6;
      if (celDate > 31) {
        let monthNew = parseInt(date[1]) + 1;
        let yearNew = parseInt(date[0]);
        let calMonthNew = monthNew;
        if (monthNew > 12) {
          yearNew = parseInt(date[0]) + 1;
          calMonthNew = monthNew - 12;
        }
        let dayCount = this.daysInMonth(date[1], yearNew);
        let cal = parseInt(dayCount) - celDate;
        let result = Math.abs(cal);
        let newMonth = moment(`${yearNew}-${calMonthNew}-${result}`).format(
          "YYYY-MM-DD"
        );
        this.dates.push(newMonth);
      } else {
        let newDate = moment(`${date[0]}-${date[1]}-${celDate}`).format(
          "YYYY-MM-DD"
        );
        this.dates.push(newDate);
      }
    },
  },
};
</script>

<style></style>
